#pragma once

#include "ofMain.h"
#include "ofAppEGLWindow.h"

extern "C" 
{
	#include "bcm_host.h"
	#include "ilclient.h"
};
#include "IL/OMX_Core.h"




class ofxOmxRpiVideoPlayer: public ofThread
{
public:
	ofxOmxRpiVideoPlayer();
	~ofxOmxRpiVideoPlayer();
	void setup(int width, int height);
	void threadedFunction();
	EGLImageKHR eglImage;
	EGLDisplay display;
	EGLContext context;
	
	OMX_BUFFERHEADERTYPE* eglBuffer;
	COMPONENT_T* renderer;
	int CLOCK_OUTPUT_PORT;
	int DECODER_INPUT_PORT;
	int DECODER_OUTPUT_PORT;
	int SCHEDULER_INPUT_PORT;
	int SCHEDULER_OUTPUT_PORT;
	int SCHEDULER_COMMUNICATION_PORT;
	int EGL_RENDER_INPUT_PORT;
	int EGL_RENDER_OUTPUT_PORT;
	const char* filename;
	COMPONENT_T* decoder;
	COMPONENT_T* scheduler;
	COMPONENT_T* clock;
	COMPONENT_T *components[5];
	TUNNEL_T tunnel[4];
	ILCLIENT_T *client;
	
	FILE *file;
	int status;
	unsigned char * data;
	unsigned int dataLength;
	int find_start_codes;
	int packet_size; 
	OMX_VIDEO_PARAM_PORTFORMATTYPE format;
	OMX_TIME_CONFIG_CLOCKSTATETYPE clockState;
	
	int initComponents();
	void closeComponents();
	bool doLoopVideo;
	
	ofTexture textureSource;
	GLuint texture;
};