#include "testApp.h"

ofShader shader;

ofFbo fbo;
//--------------------------------------------------------------
void testApp::setup(){
	ofSetLogLevel(OF_LOG_VERBOSE);
	
	ofDisableArbTex();

	shader.load("PostProcessing.vert", "PostProcessing.frag", "");
	
	fbo.allocate(ofGetWidth(), ofGetHeight());
	fbo.begin();
		ofClear(0, 0, 0, 0);
	fbo.end();

	videoPlayer.setup(1920, 1080);
	ofEnableAlphaBlending();
}

//--------------------------------------------------------------
void testApp::update(){
	fbo.begin();
	ofClear(0, 0, 0, 0);
	shader.begin();
		shader.setUniformTexture("tex0", videoPlayer.textureSource, videoPlayer.texture);
		//	textureSource.draw(0, 0, ofGetWidth(), ofGetHeight());
		shader.setUniform1f("time", ofGetElapsedTimef());
		shader.setUniform2f("resolution", ofGetWidth(), ofGetHeight());
		ofRect(0, 0, ofGetWidth(), ofGetHeight());

	shader.end();
	fbo.end();

}

//--------------------------------------------------------------
void testApp::draw(){
	fbo.draw(0, 0);
	//textureSource.draw(0, 0, textureSource.getWidth()/4, textureSource.getHeight()/4);
	//videoPlayer.textureSource.draw(0, 0);
	ofDrawBitmapStringHighlight(ofToString(ofGetFrameRate()), 200, 200, ofColor::black, ofColor::yellow);
	
}
void testApp::exit()
{
	videoPlayer.stopThread();
}
//--------------------------------------------------------------
void testApp::keyPressed  (int key){

	
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){


}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}


//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void testApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void testApp::dragEvent(ofDragInfo dragInfo){ 

}

